Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 68392)
@@ -430,5 +430,4 @@
 	src/widgets/UIApplianceExportEditorWidget.h \
 	src/widgets/UIApplianceImportEditorWidget.h \
-	src/widgets/UIBar.h \
 	src/widgets/UIBootTable.h \
 	src/widgets/UIFilePathSelector.h \
@@ -749,5 +748,4 @@
 	src/widgets/UIApplianceExportEditorWidget.cpp \
 	src/widgets/UIApplianceImportEditorWidget.cpp \
-	src/widgets/UIBar.cpp \
 	src/widgets/UIBootTable.cpp \
 	src/widgets/UIFilePathSelector.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.cpp	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.cpp	(revision 68392)
@@ -267,18 +267,2 @@
 }
 
-QPixmap betaLabelSleeve(const QSize &ls /* = QSize(80, 16) */)
-{
-    const QImage &i = betaLabelImage(ls);
-    /* Create a secondary image which will contain the rotated banner. */
-    int w = (int)sqrtf(powf(ls.width(), 2) / 2);
-    QImage i1(w, w, QImage::Format_ARGB32);
-    i1.fill(Qt::transparent);
-    QPainter p1(&i1);
-    p1.setRenderHints(QPainter::SmoothPixmapTransform);
-    p1.rotate(45);
-    p1.drawImage(0, -ls.height(), i);
-    p1.end();
-
-    return QPixmap::fromImage(i1);
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.h	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIImageTools.h	(revision 68392)
@@ -29,5 +29,4 @@
 
 QPixmap betaLabel(const QSize &ls = QSize(80, 16));
-QPixmap betaLabelSleeve(const QSize &ls = QSize(80, 16));
 
 #endif /* !__UIImageTools_h__ */
Index: trunk/src/VBox/Frontends/VirtualBox/src/precomp.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/precomp.h	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/precomp.h	(revision 68392)
@@ -428,5 +428,4 @@
 #include "UIApplianceExportEditorWidget.h"
 #include "UIApplianceImportEditorWidget.h"
-#include "UIBar.h"
 #include "UIBootTable.h"
 #ifdef RT_OS_DARWIN
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 68392)
@@ -23,4 +23,5 @@
 # include <QApplication>
 # include <QBitmap>
+# include <QMenuBar>
 # include <QWidget>
 # ifdef VBOX_WS_MAC
@@ -49,5 +50,4 @@
 # endif /* VBOX_WITH_VIDEOHWACCEL */
 # ifdef VBOX_WS_MAC
-#  include "UIMenuBar.h"
 #  include "VBoxUtils-darwin.h"
 # endif /* VBOX_WS_MAC */
@@ -1044,5 +1044,5 @@
 #ifdef VBOX_WS_MAC
         /* Create Mac OS X menu-bar: */
-        m_pMenuBar = new UIMenuBar;
+        m_pMenuBar = new QMenuBar;
         AssertPtrReturnVoid(m_pMenuBar);
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 68392)
@@ -32,5 +32,4 @@
 # include "QISplitter.h"
 # include "UIActionPoolSelector.h"
-# include "UIBar.h"
 # include "UIDesktopServices.h"
 # include "UIExtraDataManager.h"
@@ -68,4 +67,7 @@
 #  include "UIDesktopWidgetWatchdog.h"
 # endif
+# ifndef VBOX_WS_MAC
+#  include "UIMenuBar.h"
+# endif
 
 /* Other VBox stuff: */
@@ -115,7 +117,4 @@
     , m_pSlidingWidget(0)
     , m_pSplitter(0)
-#ifndef VBOX_WS_MAC
-    , m_pBar(0)
-#endif
     , m_pToolBar(0)
     , m_pTabBarMachine(0)
@@ -192,9 +191,5 @@
         /* Configure action: */
         pShowToolBar->setCheckable(true);
-#ifdef VBOX_WS_MAC
         pShowToolBar->setChecked(m_pToolBar->isVisible());
-#else /* VBOX_WS_MAC */
-        pShowToolBar->setChecked(m_pBar->isVisible());
-#endif /* !VBOX_WS_MAC */
 
         /* Add into action list: */
@@ -235,19 +230,7 @@
     {
         if (pResult->isChecked())
-        {
-#ifdef VBOX_WS_MAC
             m_pToolBar->show();
-#else /* VBOX_WS_MAC */
-            m_pBar->show();
-#endif /* !VBOX_WS_MAC */
-        }
         else
-        {
-#ifdef VBOX_WS_MAC
             m_pToolBar->hide();
-#else /* VBOX_WS_MAC */
-            m_pBar->hide();
-#endif /* !VBOX_WS_MAC */
-        }
     }
     else if (pResult == pShowToolBarText)
@@ -1345,6 +1328,6 @@
     if (vboxGlobal().isBeta())
     {
-        QPixmap betaLabel = ::betaLabelSleeve(QSize(107, 16));
-        ::darwinLabelWindow(this, &betaLabel, false);
+        QPixmap betaLabel = ::betaLabel(QSize(100, 16));
+        ::darwinLabelWindow(this, &betaLabel, true);
     }
 
@@ -1373,4 +1356,9 @@
 void UISelectorWindow::prepareMenuBar()
 {
+#ifndef VBOX_WS_MAC
+    /* Create menu-bar: */
+    setMenuBar(new UIMenuBar);
+#endif
+
     /* Create action-pool: */
     m_pActionPool = UIActionPool::create(UIActionPoolType_Selector);
@@ -1793,5 +1781,5 @@
     {
         /* Configure toolbar: */
-        m_pToolBar->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);
+        m_pToolBar->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
         m_pToolBar->setContextMenuPolicy(Qt::CustomContextMenu);
         m_pToolBar->setToolButtonStyle(Qt::ToolButtonTextUnderIcon);
@@ -1858,15 +1846,4 @@
             /* Add into toolbar: */
             m_pToolBar->addWidget(m_pToolbarTools);
-        }
-
-        /* Create/add horizontal spacer widget of fixed size for the beta label: */
-        QWidget *pSpace = new QWidget;
-        if (pSpace)
-        {
-            if (vboxGlobal().isBeta())
-                pSpace->setFixedSize(60, 1);
-            else
-                pSpace->setFixedSize(1, 1);
-            m_pToolBar->addWidget(pSpace);
         }
 
@@ -1900,23 +1877,10 @@
 
 #ifdef VBOX_WS_MAC
-
             /* Native toolbar on MAC: */
             addToolBar(m_pToolBar);
-
-#else /* !VBOX_WS_MAC */
-
-            /* Create main bar: */
-            m_pBar = new UIMainBar;
-            AssertPtrReturnVoid(m_pBar);
-            if (m_pBar)
-            {
-                /* Configure main bar: */
-                m_pBar->setContentWidget(m_pToolBar);
-
-                /* Add into layout: */
-                pLayout->addWidget(m_pBar);
-            }
-
-#endif /* !VBOX_WS_MAC */
+#else
+            /* Add into layout: */
+            pLayout->addWidget(m_pToolBar);
+#endif
 
             /* Create sliding-widget: */
@@ -2120,7 +2084,7 @@
         if (!gEDataManager->selectorWindowToolBarVisible())
             QMetaObject::invokeMethod(m_pToolBar, "hide", Qt::QueuedConnection);
-#else /* VBOX_WS_MAC */
-        m_pBar->setHidden(!gEDataManager->selectorWindowToolBarVisible());
-#endif /* !VBOX_WS_MAC */
+#else
+        m_pToolBar->setHidden(!gEDataManager->selectorWindowToolBarVisible());
+#endif
         m_pToolBar->setToolButtonStyle(gEDataManager->selectorWindowToolBarTextVisible()
                                        ? Qt::ToolButtonTextUnderIcon : Qt::ToolButtonIconOnly);
@@ -2160,9 +2124,5 @@
     /* Save toolbar and statusbar visibility: */
     {
-#ifdef VBOX_WS_MAC
         gEDataManager->setSelectorWindowToolBarVisible(!m_pToolBar->isHidden());
-#else /* VBOX_WS_MAC */
-        gEDataManager->setSelectorWindowToolBarVisible(!m_pBar->isHidden());
-#endif /* !VBOX_WS_MAC */
         gEDataManager->setSelectorWindowToolBarTextVisible(m_pToolBar->toolButtonStyle() == Qt::ToolButtonTextUnderIcon);
         gEDataManager->setSelectorWindowStatusBarVisible(!statusBar()->isHidden());
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 68373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 68392)
@@ -36,7 +36,4 @@
 class UIActionPool;
 class UIGChooser;
-#ifndef VBOX_WS_MAC
-class UIMainBar;
-#endif
 class UISlidingWidget;
 class UITabBar;
@@ -337,8 +334,4 @@
     QISplitter *m_pSplitter;
 
-#ifndef VBOX_WS_MAC
-    /** Holds the main bar instance. */
-    UIMainBar *m_pBar;
-#endif
     /** Holds the main toolbar instance. */
     UIToolBar *m_pToolBar;
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIBar.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIBar.cpp	(revision 68373)
+++ 	(revision )
@@ -1,144 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIBar class implementation.
- */
-
-/*
- * Copyright (C) 2010-2016 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifdef VBOX_WITH_PRECOMPILED_HEADERS
-# include <precomp.h>
-#else  /* !VBOX_WITH_PRECOMPILED_HEADERS */
-
-/* Local includes */
-# include "UIBar.h"
-# include "UIImageTools.h"
-# include "VBoxGlobal.h"
-
-/* Global includes */
-# include <QPaintEvent>
-# include <QPainter>
-# include <QVBoxLayout>
-# include <QPixmapCache>
-
-#endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
-
-
-UIBar::UIBar(QWidget *pParent /* = 0 */)
-  : QWidget(pParent)
-  , m_pContentWidget(0)
-{
-    setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-    QVBoxLayout *pMainLayout = new QVBoxLayout(this);
-    pMainLayout->setContentsMargins(0, 2, 0, 2);
-}
-
-void UIBar::setContentWidget(QWidget *pWidget)
-{
-    QLayout *pLayout = layout();
-    if (m_pContentWidget)
-        pLayout->removeWidget(m_pContentWidget);
-    pLayout->addWidget(pWidget);
-//    pLayout->setAlignment(pWidget, Qt::AlignCenter);
-    m_pContentWidget = pWidget;
-}
-
-QWidget* UIBar::contentWidget() const
-{
-    return m_pContentWidget;
-}
-
-QSize UIBar::sizeHint() const
-{
-    return QSize(0, 0);
-}
-
-void UIBar::paintEvent(QPaintEvent *pEvent)
-{
-    QPainter painter(this);
-    painter.setClipRect(pEvent->rect());
-
-#ifdef VBOX_WS_MAC
-    paintContentDarwin(&painter);
-#else /* VBOX_WS_MAC */
-    paintContent(&painter);
-#endif /* !VBOX_WS_MAC */
-}
-
-#ifdef VBOX_WS_MAC
-
-void UIBar::paintContentDarwin(QPainter *pPainter)
-{
-    QSize s = size();
-    QLinearGradient lg(0, 1, 0, s.height() - 2);
-    lg.setColorAt(0, QColor(233, 233, 233));
-    lg.setColorAt(1, QColor(208, 208, 208));
-//    pPainter->setPen(QColor(64, 64, 64));
-//    pPainter->drawLine(0, 0, s.width(), 0);
-    pPainter->setPen(QColor(147, 147, 147));
-    pPainter->drawLine(0, s.height()-1, s.width(), s.height()-1);
-    pPainter->setPen(Qt::NoPen);
-    pPainter->setBrush(lg);
-    pPainter->drawRect(0, 1, s.width(), s.height()- 2);
-}
-
-#else /* VBOX_WS_MAC */
-
-void UIBar::paintContent(QPainter *pPainter)
-{
-    QSize s = size();
-    QPalette pal = palette();
-    QColor base = pal.color(QPalette::Active, QPalette::Window);
-    QLinearGradient lg(0, 1, 0, s.height() - 2);
-    lg.setColorAt(0, base);
-    lg.setColorAt(.49, base.darker(102));
-    lg.setColorAt(.50, base.darker(104));
-    lg.setColorAt(1., base.darker(106));
-    pPainter->setPen(base.darker(60));
-    pPainter->drawLine(0, 0, s.width(), 0);
-    pPainter->setPen(base.darker(125));
-    pPainter->drawLine(0, s.height()-1, s.width(), s.height()-1);
-    pPainter->setPen(Qt::NoPen);
-    pPainter->setBrush(lg);
-    pPainter->drawRect(0, 1, s.width(), s.height()-2);
-}
-
-#endif /* !VBOX_WS_MAC */
-
-UIMainBar::UIMainBar(QWidget *pParent /* = 0 */)
-  : UIBar(pParent)
-  , m_fShowBetaLabel(false)
-{
-    /* Check for beta versions */
-    if (vboxGlobal().isBeta())
-        m_fShowBetaLabel = true;
-}
-
-void UIMainBar::paintEvent(QPaintEvent *pEvent)
-{
-    UIBar::paintEvent(pEvent);
-    if (m_fShowBetaLabel)
-    {
-        QPixmap betaLabel;
-        const QString key("vbox:betaLabelSleeve");
-        if (!QPixmapCache::find(key, betaLabel))
-        {
-            betaLabel = ::betaLabelSleeve();
-            QPixmapCache::insert(key, betaLabel);
-        }
-        QSize s = size();
-        QPainter painter(this);
-        painter.setClipRect(pEvent->rect());
-        painter.drawPixmap(s.width() - betaLabel.width(), 0, betaLabel);
-    }
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIBar.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIBar.h	(revision 68373)
+++ 	(revision )
@@ -1,71 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIBar class declaration.
- */
-
-/*
- * Copyright (C) 2010-2016 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef __UIBar_h__
-#define __UIBar_h__
-
-/* Global includes */
-#include <QWidget>
-
-class UIBar : public QWidget
-{
-    Q_OBJECT;
-
-public:
-
-    UIBar(QWidget *pParent = 0);
-    QSize sizeHint() const;
-
-    void setContentWidget(QWidget *pWidget);
-    QWidget* contentWidget() const;
-
-protected:
-
-    void paintEvent(QPaintEvent *pEvent);
-
-#ifdef VBOX_WS_MAC
-    void paintContentDarwin(QPainter *pPainter);
-#else /* VBOX_WS_MAC */
-    void paintContent(QPainter *pPainter);
-#endif /* !VBOX_WS_MAC */
-
-private:
-
-    /* Private member vars */
-    QWidget *m_pContentWidget;
-};
-
-class UIMainBar: public UIBar
-{
-    Q_OBJECT;
-
-public:
-
-    UIMainBar(QWidget *pParent = 0);
-
-protected:
-
-    void paintEvent(QPaintEvent *pEvent);
-
-private:
-
-    /* Private member vars */
-    bool m_fShowBetaLabel;
-};
-
-#endif /* !__UIBar_h__ */
-