Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 68421)
@@ -1116,5 +1116,5 @@
 section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.2.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.2.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0da6 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -17770,3 +17770,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 03dh
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 03ch
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 68421)
@@ -1,1 +1,1 @@
-854cf294cb1f7c54bf62169e4fb5a30b *VBoxPcBios286.rom
+38ab8a791e08812ddd515cba69fbc2ca *VBoxPcBios286.rom
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 68421)
@@ -1080,5 +1080,5 @@
 section CONST2 progbits vstart=0xda0 align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0da0 LB 0x18
-    db  'VirtualBox 5.2.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.2.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0db8 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -17282,3 +17282,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 020h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 01fh
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 68421)
@@ -1,1 +1,1 @@
-c1a8ae98c9a136255d8b6646740f698c *VBoxPcBios386.rom
+bb36e6b39714445178c921cdba41c93c *VBoxPcBios386.rom
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 68421)
@@ -1116,5 +1116,5 @@
 section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.2.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.2.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0da6 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -18244,3 +18244,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 0f9h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 0f8h
Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 68290)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 68421)
@@ -1,1 +1,1 @@
-e5b242e719ad26ca22448575914e8257 *VBoxPcBios8086.rom
+7b0984c1dd5256095d590debedcd6744 *VBoxPcBios8086.rom